diff --git a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
index 8f2757d95..dac770d19 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
@@ -1,33 +1,33 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelZombie;
-import net.minecraft.core.entity.monster.EntityArmoredZombie;
+import net.minecraft.client.render.model.ZombieModel;
+import net.minecraft.core.entity.monster.ZombieArmoredMob;
 
-public class ArmoredZombieRenderer extends MobRenderer<EntityArmoredZombie>
+public class ArmoredZombieRenderer extends BipedRenderer<ZombieArmoredMob>
 {
 
-    private final ModelZombie modelArmorChestplate;
-    private final ModelZombie modelArmor;
+    private final ZombieModel modelArmorChestplate;
+    private final ZombieModel modelArmor;
 
-    public ArmoredZombieRenderer(ModelZombie model, float shadowSize)
+    public ArmoredZombieRenderer(ZombieModel model, float shadowSize)
     {
         super(model, shadowSize);
         modelBipedMain = model;
-        modelArmorChestplate = new ModelZombie(1.0F);
-        modelArmor = new ModelZombie(0.5F);
+        modelArmorChestplate = new ZombieModel(1.0F);
+        modelArmor = new ZombieModel(0.5F);
     }
 
-    protected boolean setArmorModel(EntityArmoredZombie zombie, int renderPass, float partialTick)
+    protected boolean setArmorModel(ZombieArmoredMob zombie, int renderPass, float partialTick)
     {
-        loadTexture("/assets/minecraft/textures/armor/chain" + "_" + (renderPass != 2 ? 1 : 2) + ".png");
-        ModelZombie model = renderPass != 2 ? modelArmorChestplate : modelArmor;
-        model.bipedHead.showModel = renderPass == 0;
-        model.bipedHeadOverlay.showModel = renderPass == 0;
-        model.bipedBody.showModel = renderPass == 1 || renderPass == 2;
-        model.bipedRightArm.showModel = renderPass == 1;
-        model.bipedLeftArm.showModel = renderPass == 1;
-        model.bipedRightLeg.showModel = renderPass == 2 || renderPass == 3;
-        model.bipedLeftLeg.showModel = renderPass == 2 || renderPass == 3;
+        bindTexture("/assets/minecraft/textures/armor/chain" + "_" + (renderPass != 2 ? 1 : 2) + ".png");
+        ZombieModel model = renderPass != 2 ? modelArmorChestplate : modelArmor;
+        model.head.visible = renderPass == 0;
+        model.hair.visible = renderPass == 0;
+        model.body.visible = renderPass == 1 || renderPass == 2;
+        model.arm0.visible = renderPass == 1;
+        model.arm1.visible = renderPass == 1;
+        model.leg0.visible = renderPass == 2 || renderPass == 3;
+        model.leg1.visible = renderPass == 2 || renderPass == 3;
 
         // Disable armor pieces depending on health
         int[] armorBreakPoints = zombie.getArmorBreakPoints();
@@ -40,12 +40,12 @@ public class ArmoredZombieRenderer extends MobRenderer<EntityArmoredZombie>
             }
         }
 
-        setRenderPassModel(model);
+        setArmorModel(model);
         return true;
     }
 
     @Override
-    protected boolean shouldRenderPass(EntityArmoredZombie zombie, int renderPass, float partialTick)
+    protected boolean prepareArmor(ZombieArmoredMob zombie, int renderPass, float partialTick)
     {
         return setArmorModel(zombie, renderPass, partialTick);
     }
@@ -54,25 +54,25 @@ public class ArmoredZombieRenderer extends MobRenderer<EntityArmoredZombie>
     {
         if (piece == 0)
         {
-            modelArmorChestplate.bipedHead.showModel = false;
-            modelArmorChestplate.bipedHeadOverlay.showModel = false;
+            modelArmorChestplate.head.visible = false;
+            modelArmorChestplate.hair.visible = false;
         }
         else if (piece == 1)
         {
-            modelArmorChestplate.bipedBody.showModel = false;
-            modelArmorChestplate.bipedLeftArm.showModel = false;
-            modelArmorChestplate.bipedRightArm.showModel = false;
+            modelArmorChestplate.body.visible = false;
+            modelArmorChestplate.arm1.visible = false;
+            modelArmorChestplate.arm0.visible = false;
         }
         else if (piece == 2)
         {
-            modelArmor.bipedBody.showModel = false;
-            modelArmor.bipedLeftLeg.showModel = false;
-            modelArmor.bipedRightLeg.showModel = false;
+            modelArmor.body.visible = false;
+            modelArmor.leg1.visible = false;
+            modelArmor.leg0.visible = false;
         }
         else if (piece == 3)
         {
-            modelArmorChestplate.bipedLeftLeg.showModel = false;
-            modelArmorChestplate.bipedRightLeg.showModel = false;
+            modelArmorChestplate.leg1.visible = false;
+            modelArmorChestplate.leg0.visible = false;
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
index 954d1491d..b85f5fa39 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
@@ -1,36 +1,23 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.projectile.EntityArrow;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
-public class ArrowRenderer extends EntityRenderer<EntityArrow>
+public class ArrowRenderer extends EntityRenderer<ArrowProjectile>
 {
-    public void renderArrow(EntityArrow arrow, double x, double y, double z,
-                            float yaw, float partialTick)
-    {
-        loadTexture("/assets/minecraft/textures/entity/arrows.png");
+    @Override
+    public void render(Tessellator tessellator, ArrowProjectile arrow, double x, double y, double z,
+                       float yaw, float partialTick) {
+        bindTexture("/assets/minecraft/textures/entity/arrows.png");
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
         GL11.glRotatef((arrow.yRotO + (arrow.yRot - arrow.yRotO) * partialTick) - 90F, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(arrow.xRotO + (arrow.xRot - arrow.xRotO) * partialTick, 0.0F, 0.0F, 1.0F);
-        Tessellator tessellator = Tessellator.instance;
 
-        int arrowType;
-        if (arrow.getArrowType() == 2)
-        {
-        	arrowType = 2;
-        }
-        else if (arrow.getArrowType() == 1)
-        {
-        	arrowType = 1;
-        }
-        else
-        {
-        	arrowType = 0;
-        }
+        int arrowType = arrow.getArrowType();
 
         float bodyMinU = 0F / 32F;
         float bodyMaxU = 16F / 32F;
@@ -87,11 +74,4 @@ public class ArrowRenderer extends EntityRenderer<EntityArrow>
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glPopMatrix();
     }
-
-    @Override
-    public void doRender(Tessellator tessellator, EntityArrow entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
-        renderArrow(entity, x, y, z, yaw, partialTick);
-    }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java b/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java
new file mode 100644
index 000000000..590cfab6e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.model.BipedModel;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.item.ItemStack;
+import org.lwjgl.opengl.GL11;
+
+// Referenced classes of package net.minecraft.src:
+//            RenderLiving, Mob, BipedModel, ModelRenderer,
+//            ItemStack, Block, RenderBlocks, Item, 
+//            RenderManager, ItemRenderer
+
+public class BipedRenderer<T extends Mob> extends MobRenderer<T>
+{
+
+    public BipedRenderer(BipedModel model, float shadowSize)
+    {
+        super(model, shadowSize);
+        modelBipedMain = model;
+    }
+
+	@Override
+	protected void renderAdditional(T entity, float f) {
+		ItemStack itemstack = entity.getHeldItem();
+		if(itemstack != null) {
+			GL11.glPushMatrix();
+			modelBipedMain.arm0.translateTo(0.0625F);
+			ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack, true);
+			GL11.glPopMatrix();
+		}
+	}
+
+    protected BipedModel modelBipedMain;
+}
diff --git a/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java b/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
index 30c469ce7..ec4bf0bfd 100644
--- a/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
@@ -1,23 +1,23 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelBoat;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.client.render.model.BoatModel;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.tileentity.TileEntityRendererFlag;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.client.render.blockentity.FlagBlockEntityRenderer;
+import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.wind.WindManager;
+import net.minecraft.core.world.wind.WindProvider;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            Render, ModelBoat, EntityBoat, MathHelper, 
-//            ModelBase, Entity
+//            Render, BoatModel, BoatEntity, MathHelper,
+//            BaseModel, Entity
 
-public class BoatRenderer extends EntityRenderer<EntityBoat>
+public class BoatRenderer extends EntityRenderer<BoatEntity>
 {
 	
 	private final Minecraft mc = Minecraft.getMinecraft(this);
@@ -25,30 +25,31 @@ public class BoatRenderer extends EntityRenderer<EntityBoat>
     public BoatRenderer()
     {
         shadowSize = 0.5F;
-        modelBoat = new ModelBoat();
-        flagRenderer.setRenderDispatcher(TileEntityRenderDispatcher.instance);
+        modelBoat = new BoatModel();
+        flagRenderer.setRenderDispatcher(BlockEntityRenderDispatcher.instance);
     }
 
-    public void func_157_a(EntityBoat entity, double x, double y, double z,
-                           float yaw, float partialTick)
+    @Override
+    public void render(Tessellator tessellator, BoatEntity entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
         GL11.glRotatef(180F - yaw, 0.0F, 1.0F, 0.0F);
-        float f2 = (float)entity.boatTimeSinceHit - partialTick;
-        float f3 = (float)entity.boatCurrentDamage - partialTick;
-        if(f3 < 0.0F)
+        float hurt = (float)entity.boatTimeSinceHit - partialTick;
+        float dmg = (float)entity.boatCurrentDamage - partialTick;
+        if(dmg < 0.0F)
         {
-            f3 = 0.0F;
+            dmg = 0.0F;
         }
-        if(f2 > 0.0F)
+        if(hurt > 0.0F)
         {
-            GL11.glRotatef(((MathHelper.sin(f2) * f2 * f3) / 10F) * (float)entity.boatRockDirection, 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(((MathHelper.sin(hurt) * hurt * dmg) / 10F) * (float)entity.boatRockDirection, 1.0F, 0.0F, 0.0F);
         }
         if (entity.tileEntityFlag != null)
         {
             World theWorld = mc.theWorld;
-            WindManager theWind = theWorld.getWorldType().getWindManager();
+            WindProvider theWind = theWorld.getWorldType().getWindManager();
 
             float windAngle = theWind.getWindDirection(theWorld, (float) x, (float) y, (float) z) * 360f + (180 - yaw);
             float boatAngle = 180;
@@ -60,23 +61,16 @@ public class BoatRenderer extends EntityRenderer<EntityBoat>
 
             flagRenderer.doRender(entity.tileEntityFlag, -1.19, 0.187, -0.5, partialTick, false, angle, 1.0f);
         }
-        TextureRegistry.blockAtlas.bindTexture();
+        TextureRegistry.blockAtlas.bind();
         float f4 = 0.75F;
         GL11.glScalef(f4, f4, f4);
         GL11.glScalef(1.0F / f4, 1.0F / f4, 1.0F / f4);
-        loadTexture("/assets/minecraft/textures/entity/boat.png");
+        bindTexture("/assets/minecraft/textures/entity/boat.png");
         GL11.glScalef(-1F, -1F, 1.0F);
         modelBoat.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
         GL11.glPopMatrix();
     }
 
-    @Override
-    public void doRender(Tessellator tessellator, EntityBoat entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
-        func_157_a(entity, x, y, z, yaw, partialTick);
-    }
-
-    protected ModelBase modelBoat;
-    private TileEntityRendererFlag flagRenderer = new TileEntityRendererFlag();
+    protected BaseModel modelBoat;
+    private FlagBlockEntityRenderer flagRenderer = new FlagBlockEntityRenderer();
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java b/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java
index 5a0b70832..1e54c9272 100644
--- a/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java
@@ -1,41 +1,41 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelCannonball;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.client.render.model.CannonballModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.projectile.EntityCannonball;
+import net.minecraft.core.entity.projectile.CannonballProjectile;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            Render, Tessellator, MathHelper,
 //            Entity
 
-public class CannonballRenderer extends EntityRenderer<EntityCannonball>
+public class CannonballRenderer extends EntityRenderer<CannonballProjectile>
 {
 
     public CannonballRenderer()
     {
-        modelCannonball = new ModelCannonball();
+        modelCannonball = new CannonballModel();
     }
 
-    public void RenderCannonball(EntityCannonball entity, double d, double d1, double d2,
+    public void RenderCannonball(CannonballProjectile entity, double d, double d1, double d2,
                                  float f)
     {
         GL11.glPushMatrix();
         GL11.glTranslatef((float)d, (float)d1, (float)d2);
         GL11.glRotatef(180F - f, 0.0F, 1.0F, 0.0F);
-        loadTexture("/assets/minecraft/textures/entity/cannonball.png");
+        bindTexture("/assets/minecraft/textures/entity/cannonball.png");
         GL11.glScalef(-1F, -1F, 1.0F);
         modelCannonball.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.03125F);
         GL11.glPopMatrix();
     }
 
     @Override
-    public void doRender(Tessellator tessellator, EntityCannonball entity, double x, double y, double z,
-                         float yaw, float partialTick)
+    public void render(Tessellator tessellator, CannonballProjectile entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         RenderCannonball(entity, x, y, z, yaw);
     }
 
-    protected ModelBase modelCannonball;
+    protected BaseModel modelCannonball;
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/entity/ChickenRenderer.java b/src/main/java/net/minecraft/client/render/entity/ChickenRenderer.java
index ec72acb65..f55022f8a 100644
--- a/src/main/java/net/minecraft/client/render/entity/ChickenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ChickenRenderer.java
@@ -2,52 +2,23 @@ package net.minecraft.client.render.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntityChicken, MathHelper, ModelBase, 
-//            EntityLiving, Entity
+//            RenderLiving, ChickenMob, MathHelper, BaseModel,
+//            Mob, Entity
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.animal.EntityChicken;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.core.entity.animal.ChickenMob;
 import net.minecraft.core.util.helper.MathHelper;
 
-public class ChickenRenderer extends LivingRenderer<EntityChicken>
-{
-
-    public ChickenRenderer(ModelBase modelbase, float f)
+public class ChickenRenderer extends MobRenderer<ChickenMob> {
+    public ChickenRenderer(BaseModel modelbase, float f)
     {
         super(modelbase, f);
     }
-
-    private void renderChicken(EntityChicken entity, double d, double d1, double d2,
-                              float f, float f1)
-    {
-        super.render(entity, d, d1, d2, f, f1);
-    }
-
-    protected float getWingRotation(EntityChicken entity, float f)
-    {
-        float f1 = entity.field_756_e + (entity.field_752_b - entity.field_756_e) * f;
-        float f2 = entity.field_757_d + (entity.destPos - entity.field_757_d) * f;
-        return (MathHelper.sin(f1) + 1.0F) * f2;
-    }
-
-    @Override
-    protected float ticksExisted(EntityChicken entity, float partialTick)
-    {
-        return getWingRotation(entity, partialTick);
-    }
-
     @Override
-    public void render(EntityChicken entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        renderChicken(entity, x, y, z, yaw, partialTick);
+    protected float limbSway(ChickenMob entity, float partialTick) {
+        float flap = entity.oFlap + (entity.flap - entity.oFlap) * partialTick;
+        float flapSpeed = entity.oFlapSpeed + (entity.flapSpeed - entity.oFlapSpeed) * partialTick;
+        return (MathHelper.sin(flap) + 1.0F) * flapSpeed;
     }
 
-    @Override
-    public void doRender(Tessellator tessellator, EntityChicken entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
-        renderChicken(entity, x, y, z, yaw, partialTick);
-    }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/CowRenderer.java b/src/main/java/net/minecraft/client/render/entity/CowRenderer.java
index 038036d44..1d8075b3a 100644
--- a/src/main/java/net/minecraft/client/render/entity/CowRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/CowRenderer.java
@@ -1,39 +1,13 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.core.entity.animal.CowMob;
 
-// Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntityCow, ModelBase, EntityLiving, 
-//            Entity
-
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.animal.EntityCow;
-
-public class CowRenderer extends LivingRenderer<EntityCow>
+public class CowRenderer extends MobRenderer<CowMob>
 {
-
-    public CowRenderer(ModelBase modelbase, float f)
+    public CowRenderer(BaseModel modelbase, float f)
     {
         super(modelbase, f);
     }
 
-    public void renderCow(EntityCow entitycow, double d, double d1, double d2,
-                          float f, float f1)
-    {
-        super.render(entitycow, d, d1, d2, f, f1);
-    }
-
-    @Override
-    public void render(EntityCow entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        renderCow(entity, x, y, z, yaw, partialTick);
-    }
-
-    @Override
-    public void doRender(Tessellator tessellator, EntityCow entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
-        renderCow(entity, x, y, z, yaw, partialTick);
-    }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/CreeperRenderer.java b/src/main/java/net/minecraft/client/render/entity/CreeperRenderer.java
index 01baf081e..c13444668 100644
--- a/src/main/java/net/minecraft/client/render/entity/CreeperRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/CreeperRenderer.java
@@ -1,128 +1,93 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelCreeper;
-import net.minecraft.core.entity.monster.EntityCreeper;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.client.render.model.CreeperModel;
+import net.minecraft.core.entity.monster.CreeperMob;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, ModelCreeper, EntityCreeper, MathHelper, 
-//            ModelBase, EntityLiving
+//            RenderLiving, CreeperModel, CreeperMob, MathHelper,
+//            BaseModel, Mob
 
-public class CreeperRenderer extends LivingRenderer<EntityCreeper>
+public class CreeperRenderer extends MobRenderer<CreeperMob>
 {
-
     public CreeperRenderer()
     {
-        super(new ModelCreeper(), 0.5F);
-        field_27008_a = new ModelCreeper(2.0F);
+        super(new CreeperModel(), 0.5F);
+        chargedModel = new CreeperModel(2.0F);
     }
 
-    protected void updateCreeperScale(EntityCreeper entity, float f)
-    {
-        float f1 = entity.setCreeperFlashTime(f);
-        float f2 = 1.0F + MathHelper.sin(f1 * 100F) * f1 * 0.01F;
-        if(f1 < 0.0F)
-        {
-            f1 = 0.0F;
+    @Override
+    protected void setupScale(CreeperMob creeper, float partialTick) {
+        float g = creeper.getSwelling(partialTick);
+        final float wobble = 1.0f + MathHelper.sin(g * 100.0f) * g * 0.01f;
+        if (g < 0.0f) {
+            g = 0.0f;
         }
-        if(f1 > 1.0F)
-        {
-            f1 = 1.0F;
+        if (g > 1.0f) {
+            g = 1.0f;
         }
-        f1 *= f1;
-        f1 *= f1;
-        float f3 = (1.0F + f1 * 0.4F) * f2;
-        float f4 = (1.0F + f1 * 0.1F) / f2;
-        GL11.glScalef(f3, f4, f3);
+        g *= g;
+        g *= g;
+        final float s = (1.0f + g * 0.4f) * wobble;
+        final float hs = (1.0f + g * 0.1f) / wobble;
+        GL11.glScalef(s, hs, s);
     }
 
-    protected int updateCreeperColorMultiplier(EntityCreeper entity, float f, float f1)
-    {
-        float f2 = entity.setCreeperFlashTime(f1);
-        if((int)(f2 * 10F) % 2 == 0)
-        {
+    @Override
+    protected int getOverlayColor(CreeperMob creeper, float brightness, float partialTick) {
+        final float step = creeper.getSwelling(partialTick);
+        if ((int)(step * 10.0f) % 2 == 0) {
             return 0;
         }
-        int i = (int)(f2 * 0.2F * 255F);
-        if(i < 0)
-        {
-            i = 0;
+        int _a = (int)(step * 0.2f * 255.0f);
+        if (_a < 0) {
+            _a = 0;
         }
-        if(i > 255)
-        {
-            i = 255;
+        if (_a > 255) {
+            _a = 255;
         }
-        char c = '\377';
-        char c1 = '\377';
-        char c2 = '\377';
-        return i << 24 | c << 16 | c1 << 8 | c2;
+        final int r = 255;
+        final int g = 255;
+        final int b = 255;
+        return _a << 24 | r << 16 | g << 8 | b;
     }
 
-    protected boolean func_27006_a(EntityCreeper entity, int i, float f)
-    {
+    @Override
+    protected boolean prepareArmor(CreeperMob entity, int layer, float partialTick) {
         if(entity.getPowered())
         {
-            if(i == 1)
+            if(layer == 1)
             {
-                float f1 = (float)entity.tickCount + f;
-                loadTexture("/armor/power.png");
-                GL11.glMatrixMode(5890 /*GL_TEXTURE*/);
+                float f1 = (float)entity.tickCount + partialTick;
+                bindTexture("/armor/power.png");
+                GL11.glMatrixMode(GL11.GL_TEXTURE);
                 GL11.glLoadIdentity();
                 float f2 = f1 * 0.01F;
                 float f3 = f1 * 0.01F;
                 GL11.glTranslatef(f2, f3, 0.0F);
-                setRenderPassModel(field_27008_a);
-                GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
-                GL11.glEnable(3042 /*GL_BLEND*/);
-                float f4 = 0.5F;
-                GL11.glColor4f(f4, f4, f4, 1.0F);
-                GL11.glDisable(2896 /*GL_LIGHTING*/);
+                setArmorModel(chargedModel);
+                GL11.glMatrixMode(GL11.GL_MODELVIEW);
+                GL11.glEnable(GL11.GL_BLEND);
+                float brightness = 0.5F;
+                GL11.glColor4f(brightness, brightness, brightness, 1.0F);
+                GL11.glDisable(GL11.GL_LIGHTING);
                 GL11.glBlendFunc(1, 1);
                 return true;
             }
-            if(i == 2)
+            if(layer == 2)
             {
-                GL11.glMatrixMode(5890 /*GL_TEXTURE*/);
+                GL11.glMatrixMode(GL11.GL_TEXTURE);
                 GL11.glLoadIdentity();
-                GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
-                GL11.glEnable(2896 /*GL_LIGHTING*/);
-                GL11.glDisable(3042 /*GL_BLEND*/);
+                GL11.glMatrixMode(GL11.GL_MODELVIEW);
+                GL11.glEnable(GL11.GL_LIGHTING);
+                GL11.glDisable(GL11.GL_BLEND);
             }
         }
         return false;
     }
 
-    protected boolean func_27007_b(EntityCreeper entity, int i, float f)
-    {
-        return false;
-    }
-
-    @Override
-    protected void preRenderCallback(EntityCreeper entity, float f)
-    {
-
-        updateCreeperScale(entity, f);
-    }
-
-    @Override
-    protected int getColorMultiplier(EntityCreeper entity, float f, float f1)
-    {
-        return updateCreeperColorMultiplier(entity, f, f1);
-    }
-
-    @Override
-    protected boolean shouldRenderPass(EntityCreeper entity, int renderPass, float partialTick)
-    {
-        return func_27006_a(entity, renderPass, partialTick);
-    }
-
-    @Override
-    protected boolean shouldRenderPassB(EntityCreeper entity, int renderPass, float partialTick)
-    {
-        return func_27007_b(entity, renderPass, partialTick);
-    }
 
-    private ModelBase field_27008_a;
+    private BaseModel chargedModel;
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/DefaultRenderer.java b/src/main/java/net/minecraft/client/render/entity/DefaultRenderer.java
index a1e3f81f6..0c1c7ef60 100644
--- a/src/main/java/net/minecraft/client/render/entity/DefaultRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/DefaultRenderer.java
@@ -10,8 +10,8 @@ import org.lwjgl.opengl.GL11;
 public class DefaultRenderer extends EntityRenderer<Entity>
 {
     @Override
-    public void doRender(Tessellator tessellator, Entity entity, double x, double y, double z,
-                         float yaw, float partialTick)
+    public void render(Tessellator tessellator, Entity entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         GL11.glPushMatrix();
         renderOffsetAABB(tessellator, entity.bb, x - entity.xo, y - entity.yo, z - entity.zo);
